# set the scripts parameters

# Set the location for the minesight files below.  Use \\ for the path of the file 10
file10 = 'E:\\ProgramData\\MineSight\\geo_dat\\geo10.dat'
file09 = 'geo09.dat'
file12 = 'geo12.dat'

# Imago Data Series Type Name (Core Boxes, Downhole, Chips, etc.)
ds = 'Core Boxes'

#Imago Imagery Type Name (Dry, Wet, Core, etc.)
im = 'Wet'

# Do not change anything below this line
im = im.replace(" ","%20")
ds = ds.replace(" ","%20")


import sys
import wx
from grail import mwx, gsys
from grail.ms3d import selectionbuffer, element
from grail.data import dh
from grail import ag
import webbrowser


class MyFrame(mwx.Frame):

    def __init__(self):
        try:
            mwx.Frame.__init__(self, None, size=(200,80), showApplyCancel=False, title="", version=1.0)
            szr = wx.GridBagSizer(hgap=10, vgap=10)
            self.ToggleWindowStyle(wx.STAY_ON_TOP)

            szr.Add(item=mwx.Button(self.panel, label = "Open Imago Image Web Site", event = self.OnButton2), pos=(0, 0))
           
            self.panel.SetSizerAndFit(sizer=szr)

        except:
            import traceback
            traceback.print_exc(file=sys.stderr)
            self.Destroy()
    

    def OnButton2(self, event):
        selectionbuffer.select_element(bar)        
        #selectionbuffer.select_element(bar, [element.ShellType])        

def bar(elem):
    #print elem
    sel_interval = elem.get_pointlist()
    # print sel_interval
 

    # open function for typical dh set (change path to dh files)
    dhset = dh.opentypicaldhset(file10, file09, file12)

    # get a list of all the drillholes in the set
    drillholes = dhset.totaldhlist()

    # loop over all the drillholes and make the calculation
    for drillhole in drillholes:
      
       # loop over all the intervals in the drillhole
       for intv in range(1, dhset.dhintervalcount(drillhole)+1):

         lngth_num = dhset.dhintervaldataat(drillhole, intv, "LNGTH")
         to_num = dhset.dhintervaldataat(drillhole, intv, "-TO-")
         
       # get the list of all intervals in the dhset
         
         plist = dhset.dhintervalcoordsat(drillhole, intv)
              
         half = len(plist)/2
         p1 = plist[:half]
         p2 = plist[half:]
         plist_final = [p1,p2]
    
         if ag.pointlist_equal(sel_interval, plist_final):

#Launch the string

             de = "{0}".format(drillhole,round(to_num,1))
             dp = "{1}".format(drillhole,round(to_num,1))
			 		 
             final_string = "https://portal.imago.live/api/display?de={0}&ds={1}&im={2}&dp={3}".format(drillhole,ds,im,round(to_num,1))
             webbrowser.open(final_string)
             
def main():
    mwx.LaunchApp(MyFrame)

gmain = gsys.GMAIN(main, __name__)
gmain.run()
